pub mod messages;
use crate::span::Span;
use messages::Message;

pub struct Log {
    pub message: Message,
    pub filename: String,
    pub span: Span,
}

pub struct Logger {
    pub logs: Vec<Log>,
}

impl Logger {
    pub fn log(&mut self, message: Message, filename: String, start: usize, end: usize) {
        self.logs.push(Log {
            message,
            filename,
            span: Span { start, end },
        })
    }
}
